QGIS 3.4 Incorrect handling of Postgres serial columns

2018-11-07 04:55 PM - Scott Werkema

Status: Closed

Priority: High

Assignee:

Category: Data Provider/PostGIS

Affected QGIS version:3.4.0 Regression?: Yes

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 28217

Description

Starting with QGIS 3.4, I am unable to digitize multiple features between saves for PostGIS layers with a serial column that has a unique

constraint. It appears the serial column's default text is triggering QGIS unique constraint enforcement.

Note: In the attached screenshot, `structure_id` is the primary key column.

Related issues:

Related to QGIS Application - Bug report # 20431: no possibility to confirm i... Closed 2018-11-09

Associated revisions

Revision 32b7d7e5 - 2018-11-19 04:54 PM - David Signer

check uniqueCheck before overwrite defaultValueClause

and some tests for it

this fixes #20397 and fixes #20431

Revision 76667eee - 2018-11-20 11:57 AM - David Signer

check uniqueCheck before overwrite defaultValueClause

and some tests for it

this fixes #20397 and fixes #20431

(cherry-picked from 32b7d7e5ddeef7a66592267819e234085c44a7bc)

History

#1 - 2018-11-07 04:56 PM - Giovanni Manghi

- Priority changed from Normal to High

- Operating System deleted (macOS 10.14.1)

#2 - 2018-11-16 10:19 AM - Burghardt Scholle

I can confirm your description with QGIS DEV code revision 7cce9b3eb9. After digitizing a new feature I have to save first before I can continue with the

next feature. Otherwise I get the same error message in the PostGIS-Tab of the log:

2018-11-16T09:53:49     WARNING    Query: DECLARE qgis_1774 BINARY CURSOR FOR SELECT

"gid","datum"::text,"bearbeiter"::text,"veranstaltung"::text,"beschriftung"::text,"name"::text,"flaechentyp"::text,"farbe"::text,"schraff_width"::text,"schraff_width_prt"::text,"schraff_size"::text,"schraff_size_prt"::text,"schraff_winkel"::text,"um
_prt"::text,"schraff_size"::text,"schraff_size_prt"::text,"schraff_winkel"::text,"umrissfarbe"::text,"umrisstyp"::text,"umrissstaerke"::text,"umrissstaerke_prt"::text,"umfang"::text,"flaeche"::text,"bemerkung"::text,"last_change"::text FROM "geofachdaten"."gis_digi_a_geo" WHERE ("gid" = 'nextval(''gis_digi_a_geo_gid_seq''::regclass)') LIMIT 1 returned 7 [ERROR: invalid input syntax for integer: »nextval('gis_

xt,"umfang"::text,"flaeche"::text,"bemerkung"::text,"last_change"::text FROM "geofachdaten"."gis_digi_a_geo" WHERE ("gid" =

'nextval(''gis_digi_a_geo_gid_seq''::regclass)') LIMIT 1 returned 7 [ERROR: invalid input syntax for integer: »nextval('gis_digi_a_geo_gid_seq'::regclass)«

             LINE 1: ...OM "geofachdaten"."gis_digi_a_geo" WHERE ("gid" = 'nextval('...

This significantly impairs the workflow during digitization.

#3 - 2018-11-16 11:21 AM - Harrissou Santanna

What happens if "evaluate default values on provider side" is checked in the project settings, as suggested in #20431?

#4 - 2018-11-16 01:33 PM - Jan Lippmann

see also here #20431

when you hide the serial field in the form you can add more than one feature without save each feature

BUT then you can run into this issue: #20433

#5 - 2018-11-17 06:35 PM - Harrissou Santanna

- Related to Bug report #20431: no possibility to confirm in the attribut form while add more than one feature (postgres) added

#6 - 2018-11-17 09:56 PM - Alessandro Pasotti

Most likely broken by https://github.com/qgis/QGIS/commit/963fdd5a7e2f29c0e282869681f107ab9f78c9aa#diff-ad7e488f21bc920cdf5407f3b17f5c42

#7 - 2018-11-20 11:15 AM - David Signer

- % Done changed from 0 to 100

- Status changed from Open to Closed

Applied in changeset commit:qgis|32b7d7e5ddeef7a66592267819e234085c44a7bc.
